VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Mount/Unmount ISO"
   ClientHeight    =   1740
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   6870
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1740
   ScaleWidth      =   6870
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frDriveLetter 
      Caption         =   "Assign DriveLetter"
      Height          =   555
      Left            =   4320
      TabIndex        =   3
      Top             =   30
      Width           =   2475
      Begin VB.ComboBox cbDriveLetter 
         Enabled         =   0   'False
         Height          =   315
         Left            =   1500
         Style           =   2  'Dropdown List
         TabIndex        =   5
         Top             =   180
         Width           =   885
      End
      Begin VB.CheckBox ckAutoDriveLetter 
         Caption         =   "Automatic"
         Height          =   195
         Left            =   120
         TabIndex        =   4
         Top             =   270
         Value           =   1  'Checked
         Width           =   1095
      End
   End
   Begin VB.CommandButton cmdListVirtDrives 
      Caption         =   "List all virtual Drives"
      Height          =   465
      Left            =   60
      TabIndex        =   2
      Top             =   1200
      Width           =   4200
   End
   Begin VB.CommandButton cmdUnmount 
      Caption         =   "Unmount ISO"
      Height          =   465
      Left            =   60
      TabIndex        =   1
      Top             =   660
      Width           =   4200
   End
   Begin VB.CommandButton cmdMount 
      Caption         =   "Mount ISO"
      Height          =   465
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   4200
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2020

Option Explicit

' entsprechend anpassen!!!
Private Const IsoFile As String = "d:\test.iso"

' ----==== Const ====----
Private Const API_TRUE As Long = &H1&
Private Const ERROR_SUCCESS As Long = &H0&
Private Const ERROR_INSUFFICIENT_BUFFER = &H7A&
Private Const MAX_PATH As Long = 260&
Private Const ATTACH_VIRTUAL_DISK_VERSION_1 As Long = &H1&
Private Const ATTACH_VIRTUAL_DISK_FLAG_READ_ONLY As Long = &H1&
Private Const ATTACH_VIRTUAL_DISK_FLAG_NO_DRIVE_LETTER As Long = &H2&
Private Const ATTACH_VIRTUAL_DISK_FLAG_PERMANENT_LIFETIME As Long = &H4&
Private Const DETACH_VIRTUAL_DISK_FLAG_NONE As Long = &H0&
Private Const OPEN_VIRTUAL_DISK_FLAG_NONE As Long = &H0&
Private Const OPEN_VIRTUAL_DISK_VERSION_1 As Long = &H1&
Private Const OPEN_VIRTUAL_DISK_RW_DEPTH_DEFAULT As Long = &H1&
Private Const VIRTUAL_DISK_ACCESS_READ As Long = &HD0000
Private Const VIRTUAL_DISK_ACCESS_DETACH  As Long = &H40000
Private Const VIRTUAL_DISK_ACCESS_GET_INFO As Long = &H80000
Private Const VIRTUAL_STORAGE_TYPE_DEVICE_ISO As Long = &H1&
Private Const VIRTUAL_STORAGE_TYPE_VENDOR_UNKNOWN As Long = &H0&
Private Const VIRTUAL_STORAGE_TYPE_VENDOR_MICROSOFT As String = "{EC984AEC-A0F9-47e9-901F-71415A66345B}"

' ----==== Types ====----
Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Type VIRTUAL_STORAGE_TYPE
    DeviceId As Long
    VendorId As Long
End Type

Private Type OPEN_VIRTUAL_DISK_PARAMETERS
    Version As Long
    RWDepth As Long
End Type

Private Type ATTACH_VIRTUAL_DISK_PARAMETERS
    Version As Long
    Reserved As Long
End Type

' ----==== Kernel32.dll ====----
Private Declare Function GetLogicalDrives Lib "Kernel32.dll" () As Long

Private Declare Function CloseHandle Lib "Kernel32.dll" ( _
                         ByVal hObject As Long) As Long
                         
Private Declare Function GetVolumeNameForVolumeMountPoint Lib "Kernel32.dll" _
                         Alias "GetVolumeNameForVolumeMountPointW" ( _
                         ByVal lpszVolumeMountPoint As Long, _
                         ByVal lpszVolumeName As Long, _
                         ByVal cchBufferLength As Long) As Long
                         
Private Declare Function GetVolumePathNamesForVolumeName Lib "Kernel32.dll" _
                         Alias "GetVolumePathNamesForVolumeNameW" ( _
                         ByVal lpszVolumeName As Long, _
                         ByVal lpszVolumePathNames As Long, _
                         ByVal cchBufferLength As Long, _
                         ByRef lpcchReturnLength As Long) As Long

Private Declare Function SetVolumeMountPoint Lib "Kernel32.dll" _
                         Alias "SetVolumeMountPointW" ( _
                         ByVal lpszVolumeMountPoint As Long, _
                         ByVal lpszVolumeName As Long) As Long
                         
' ----==== Ole32.dll ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pString As Long, _
                         ByRef pCLSID As GUID) As Long
                         
' ----==== VirtDisk.dll ====----
Private Declare Function OpenVirtualDisk Lib "VirtDisk.dll" ( _
                         ByVal VirtualStorageType As Long, _
                         ByVal Path As Long, _
                         ByVal VirtualDiskAccessMask As Long, _
                         ByVal Flags As Long, _
                         ByVal Parameters As Long, _
                         ByRef hHandle As Long) As Long
                         
Private Declare Function AttachVirtualDisk Lib "VirtDisk.dll" ( _
                         ByVal VirtualDiskHandle As Long, _
                         ByVal SecurityDescriptor As Long, _
                         ByVal Flags As Long, _
                         ByVal ProviderSpecificFlags As Long, _
                         ByVal Parameters As Long, _
                         ByVal Overlapped As Long) As Long
 
Private Declare Function DetachVirtualDisk Lib "VirtDisk.dll" ( _
                         ByVal VirtualDiskHandle As Long, _
                         ByVal Flags As Long, _
                         ByVal ProviderSpecificFlags As Long) As Long

Private Declare Function GetVirtualDiskPhysicalPath Lib "VirtDisk.dll" ( _
                         ByVal VirtualDiskHandle As Long, _
                         ByRef DiskPathSizeInBytes As Long, _
                         ByVal DiskPath As Long) As Long

Private Declare Function GetAllAttachedVirtualDiskPhysicalPaths Lib "VirtDisk.dll" ( _
                         ByRef PathListSizeInBytes As Long, _
                         ByVal PathListBuffer As Long) As Long
                         

Private Sub Form_Load()
    
    Call GetFreeLogicalDrives
    
End Sub
                         
Private Sub ckAutoDriveLetter_Click()
    
    If ckAutoDriveLetter.Value = vbChecked Then
    
        cbDriveLetter.Enabled = False
        
    Else
    
        cbDriveLetter.Enabled = True
        
    End If
    
End Sub
                         
Private Sub cmdMount_Click()

    Dim strRet As String
    Dim strDrivePath As String
    Dim strDriveLetter As String
    
    Dim hVirtFile As Long
    
    Dim lngAttachFlags As Long
    Dim lngBuffSize As Long
    
    Dim eMsgStyle As VbMsgBoxStyle
    
    Dim tVST As VIRTUAL_STORAGE_TYPE
    Dim tOVDP As OPEN_VIRTUAL_DISK_PARAMETERS
    Dim tAVDP As ATTACH_VIRTUAL_DISK_PARAMETERS
    
    With tVST
        .DeviceId = VIRTUAL_STORAGE_TYPE_DEVICE_ISO
        '.VendorId = VIRTUAL_STORAGE_TYPE_VENDOR_UNKNOWN
        .VendorId = VarPtr(Str2Guid(VIRTUAL_STORAGE_TYPE_VENDOR_MICROSOFT))
    End With
    
    With tOVDP
        .Version = OPEN_VIRTUAL_DISK_VERSION_1
        .RWDepth = OPEN_VIRTUAL_DISK_RW_DEPTH_DEFAULT
    End With
    
    With tAVDP
        .Version = ATTACH_VIRTUAL_DISK_VERSION_1
    End With
    
    ' Handle auf die ISO holen
    If OpenVirtualDisk(VarPtr(tVST), StrPtr(IsoFile), _
        VIRTUAL_DISK_ACCESS_READ Or VIRTUAL_DISK_ACCESS_GET_INFO, _
        OPEN_VIRTUAL_DISK_FLAG_NONE, VarPtr(tOVDP), hVirtFile) = ERROR_SUCCESS Then
        
        lngBuffSize = MAX_PATH
        strDrivePath = String$(lngBuffSize, vbNullChar)
            
        ' Pfad zum virtuellen Laufwerk ermitteln das der ISO zugewiesen wurde
        If GetVirtualDiskPhysicalPath(hVirtFile, lngBuffSize, _
            StrPtr(strDrivePath)) = ERROR_SUCCESS Then
            
            ' ISO ist breits geladen!
            
            strDrivePath = CutNull(strDrivePath)
            
            ' Laufwerksbuchstaben vom virtuellen Laufwerk ermitteln
            strDriveLetter = GetDriveLetterFromDrivePath(strDrivePath)
            
            strRet = "Die ISO '" & IsoFile & "' ist breits als virtuelles Laufwerk '" & _
                strDriveLetter & "' geladen!"
            
            eMsgStyle = vbExclamation
            
        Else
        
            ' ISO ist noch nicht geladen!
            
            lngAttachFlags = ATTACH_VIRTUAL_DISK_FLAG_READ_ONLY Or _
                ATTACH_VIRTUAL_DISK_FLAG_PERMANENT_LIFETIME
                
            If ckAutoDriveLetter.Value <> vbChecked Then
            
                lngAttachFlags = lngAttachFlags Or ATTACH_VIRTUAL_DISK_FLAG_NO_DRIVE_LETTER
                
            End If
        
            ' ISO mounten
            If AttachVirtualDisk(hVirtFile, 0&, lngAttachFlags, 0&, _
                VarPtr(tAVDP), 0&) = ERROR_SUCCESS Then
                
                lngBuffSize = MAX_PATH
                strDrivePath = String$(lngBuffSize, vbNullChar)
            
                ' Pfad zum virtuellen Laufwerk ermitteln das der ISO zugewiesen wurde
                If GetVirtualDiskPhysicalPath(hVirtFile, lngBuffSize, _
                    StrPtr(strDrivePath)) = ERROR_SUCCESS Then
        
                    strDrivePath = CutNull(strDrivePath)
                    
                    If ckAutoDriveLetter.Value = vbChecked Then
                    
                        ' Laufwerksbuchstaben vom virtuellen Laufwerk ermitteln
                        strDriveLetter = GetDriveLetterFromDrivePath(strDrivePath)
        
                        strRet = "Die ISO '" & IsoFile & "' wurde automatisch als virtuelles Laufwerk '" & _
                            strDriveLetter & "' geladen."
                            
                    Else
                    
                        
                        strDriveLetter = cbDriveLetter.List(cbDriveLetter.ListIndex)
                        
                        If SetVolumeMountPoint(StrPtr(strDriveLetter), _
                            StrPtr(GetVolumePathFromDrivePath(strDrivePath))) = API_TRUE Then
                        
                            strRet = "Die ISO '" & IsoFile & "' wurde als virtuelles Laufwerk '" & _
                                strDriveLetter & "' geladen."
                                
                        End If
                    
                    End If
                    
                    eMsgStyle = vbInformation
                    
                Else
                
                    strRet = "Die ISO '" & IsoFile & _
                        "' konnte nicht als virtuelles Laufwerk geladen werden!"
                        
                    eMsgStyle = vbExclamation
            
                End If
                
            End If

        End If
            
        ' Handle schlieen
        If CloseHandle(hVirtFile) <> 0& Then
        
            hVirtFile = 0&
            
        End If
        
    Else
        
        strRet = "Es konnte kein Handle von der ISO '" & _
            IsoFile & "' erstellt werden!"
        
        eMsgStyle = vbCritical
        
    End If
    
    MsgBox strRet, vbOKOnly Or eMsgStyle, "Mount ISO"
    
    Call GetFreeLogicalDrives
    
End Sub

Private Sub cmdUnmount_Click()

    Dim strRet As String
    Dim strDrivePath As String
    Dim strDriveLetter As String
    
    Dim hVirtFile As Long
    
    Dim lngBuffSize As Long
    
    Dim eMsgStyle As VbMsgBoxStyle
    
    Dim tVST As VIRTUAL_STORAGE_TYPE
    Dim tOVDP As OPEN_VIRTUAL_DISK_PARAMETERS
    
    With tVST
        .DeviceId = VIRTUAL_STORAGE_TYPE_DEVICE_ISO
        '.VendorId = VIRTUAL_STORAGE_TYPE_VENDOR_UNKNOWN
        .VendorId = VarPtr(Str2Guid(VIRTUAL_STORAGE_TYPE_VENDOR_MICROSOFT))
    End With
    
    With tOVDP
        .Version = OPEN_VIRTUAL_DISK_VERSION_1
        .RWDepth = OPEN_VIRTUAL_DISK_RW_DEPTH_DEFAULT
    End With
        
    ' Handle auf die ISO holen
    If OpenVirtualDisk(VarPtr(tVST), StrPtr(IsoFile), _
        VIRTUAL_DISK_ACCESS_DETACH Or VIRTUAL_DISK_ACCESS_GET_INFO, _
        OPEN_VIRTUAL_DISK_FLAG_NONE, VarPtr(tOVDP), _
        hVirtFile) = ERROR_SUCCESS Then
            
        lngBuffSize = MAX_PATH
        strDrivePath = String$(lngBuffSize, vbNullChar)
            
        ' Pfad zum virtuellen Laufwerk ermitteln das der ISO zugewiesen wurde
        If GetVirtualDiskPhysicalPath(hVirtFile, lngBuffSize, _
            StrPtr(strDrivePath)) = ERROR_SUCCESS Then
        
            strDrivePath = CutNull(strDrivePath)
            
            ' Laufwerksbuchstaben vom virtuellen Laufwerk ermitteln
            strDriveLetter = GetDriveLetterFromDrivePath(strDrivePath)
        
            ' ISO unmounten
            If DetachVirtualDisk(hVirtFile, DETACH_VIRTUAL_DISK_FLAG_NONE, _
                0&) = ERROR_SUCCESS Then
        
                strRet = "Die ISO '" & IsoFile & "' wurde als virtuelles Laufwerk '" & _
                    strDriveLetter & "' entfernt."
                    
                eMsgStyle = vbInformation
                
            Else
            
                strRet = "Die ISO '" & IsoFile & "' konnte nicht vom virtuellem Laufwerk '" & _
                    strDriveLetter & "' entfernt werden!"
                    
                eMsgStyle = vbExclamation
            
            End If
        
        Else
        
            strRet = "Die ISO '" & IsoFile & "' ist in keinem virtuellen Laufwerk geladen!"
            
            eMsgStyle = vbExclamation
            
        End If
        
        ' Handle schlieen
        If CloseHandle(hVirtFile) <> 0& Then
        
            hVirtFile = 0&
            
        End If
        
    Else
        
        strRet = "Es konnte kein Handle von der ISO '" & _
            IsoFile & "' erstellt werden!"
        
        eMsgStyle = vbCritical
        
    End If
    
    MsgBox strRet, vbOKOnly Or eMsgStyle, "Unmount ISO"
    
    Call GetFreeLogicalDrives
    
End Sub

Private Sub cmdListVirtDrives_Click()

    Dim hVirtFile As Long
        
    Dim bolOk As Boolean
    
    Dim lngItem As Long
    Dim lngCount As Long
    Dim lngStatus As Long
    Dim lngBuffSize As Long
    Dim lngPathListSizeInBytes As Long
    
    Dim pPathListBuffer As Long
    
    Dim strRet As String
    Dim strDrivePath As String
    Dim strPathList() As String
    Dim strDriveLetter As String
    Dim strPathListBuffer As String
    
    Dim tVST As VIRTUAL_STORAGE_TYPE
    Dim tOVDP As OPEN_VIRTUAL_DISK_PARAMETERS
    Dim tAVDP As ATTACH_VIRTUAL_DISK_PARAMETERS
   
    With tVST
        .DeviceId = VIRTUAL_STORAGE_TYPE_DEVICE_ISO
        '.VendorId = VIRTUAL_STORAGE_TYPE_VENDOR_UNKNOWN
        .VendorId = VarPtr(Str2Guid(VIRTUAL_STORAGE_TYPE_VENDOR_MICROSOFT))
    End With
    
    With tOVDP
        .Version = OPEN_VIRTUAL_DISK_VERSION_1
        .RWDepth = OPEN_VIRTUAL_DISK_RW_DEPTH_DEFAULT
    End With
    
    With tAVDP
        .Version = ATTACH_VIRTUAL_DISK_VERSION_1
    End With
   
    bolOk = False
    pPathListBuffer = 0&
    lngPathListSizeInBytes = 0&
    
    Do
        
        ' alle virtuellen Laufwerke und die darin
        ' enthaltenen Images ermitteln
        lngStatus = GetAllAttachedVirtualDiskPhysicalPaths(lngPathListSizeInBytes, _
            pPathListBuffer)
        
        ' wenn der bei der Abfrage Puffer zu klein war
        If lngStatus = ERROR_INSUFFICIENT_BUFFER Then
            
            ' Puffer entsprechend dimensionieren
            strPathListBuffer = String$(lngPathListSizeInBytes, vbNullChar)
            
            ' Pointer auf den String speichern
            pPathListBuffer = StrPtr(strPathListBuffer)
        
        End If
        
    ' durchlaufen solange der Status = ERROR_INSUFFICIENT_BUFFER ist
    Loop While lngStatus = ERROR_INSUFFICIENT_BUFFER
    
    ' strPathListBuffer splitten
    strPathList = Split(strPathListBuffer, vbNullChar)
    
    ' Anzahl der Elemente im Array ermitteln
    lngCount = UBound(strPathList)
    
    ' alle Elemente durchlaufen
    For lngItem = 0 To lngCount
    
        ' ist ein String vorhanden
        If strPathList(lngItem) <> vbNullString Then
        
            ' ist die Dateiextension ISO
            If UCase$(Mid$(strPathList(lngItem), InStrRev(strPathList(lngItem), ".") + 1)) = "ISO" Then
        
                ' Handle auf die ISO holen
                If OpenVirtualDisk(VarPtr(tVST), StrPtr(strPathList(lngItem)), _
                    VIRTUAL_DISK_ACCESS_GET_INFO, OPEN_VIRTUAL_DISK_FLAG_NONE, _
                    VarPtr(tOVDP), hVirtFile) = ERROR_SUCCESS Then
                    
                    lngBuffSize = MAX_PATH
                    strDrivePath = String$(lngBuffSize, vbNullChar)
            
                    ' Pfad zum virtuellen Laufwerk ermitteln das der ISO zugewiesen wurde
                    If GetVirtualDiskPhysicalPath(hVirtFile, lngBuffSize, _
                        StrPtr(strDrivePath)) = ERROR_SUCCESS Then
            
                        strDrivePath = CutNull(strDrivePath)
            
                        ' Laufwerksbuchstaben vom virtuellen Laufwerk ermitteln
                        strDriveLetter = GetDriveLetterFromDrivePath(strDrivePath)
            
                        strRet = strRet & "Im virtuellen Laufwerk '" & strDriveLetter & _
                            "' ist die ISO '" & strPathList(lngItem) & "' geladen." & vbNewLine
                        
                        bolOk = True
                        
                    End If
                    
                    ' Handle schlieen
                    If CloseHandle(hVirtFile) <> 0& Then
        
                        hVirtFile = 0&
            
                    End If
            
                End If
            
            End If
            
        End If
    
    Next
    
    If bolOk = True Then
    
        MsgBox strRet, vbOKOnly Or vbInformation, "List virtual Drives"

    Else
    
    
        MsgBox "Derzeit sind keine virtuellen Laufwerke mit" & _
            " geladenen ISOs vorhanden.", vbOKOnly Or vbExclamation, _
            "List all virtual Drives"
    
    End If

End Sub

Private Sub GetFreeLogicalDrives()

    Dim lngLastIndex As Long
    Dim lngDriveNum As Long
    Dim lngLogicalDrives As Long
    
    
    lngLastIndex = cbDriveLetter.ListIndex
    
    cbDriveLetter.Clear
    
    lngLogicalDrives = GetLogicalDrives

    ' alle Laufwerksnummern durchlaufen
    For lngDriveNum = 0 To 25
    
        ' ist das entsprechende Bit in lngRet = 0
        If (lngLogicalDrives And 2 ^ lngDriveNum) = 0 Then
        
            ' Laufwerksbuchstabe
            cbDriveLetter.AddItem Chr$(65 + lngDriveNum) & ":\"
            
        End If
        
        ' nchste Laufwerksnummer
    Next lngDriveNum
    
    If cbDriveLetter.ListCount > 0 Then
    
        If lngLastIndex <> -1 Then
        
            If lngLastIndex < cbDriveLetter.ListCount Then
    
                cbDriveLetter.ListIndex = lngLastIndex
                
            Else
            
                cbDriveLetter.ListIndex = cbDriveLetter.ListCount - 1
                
            End If
        
        Else
        
            cbDriveLetter.ListIndex = 0
        
        End If
        
    End If

End Sub

Private Function GetVolumePathFromDrivePath(ByVal sDrivePath As String) As String

    Dim lngBuffSize As Long
    
    Dim strRet As String
    Dim strVolume As String
    
    ' BackSlash anfgen falls nicht vorhanden
    If Right$(sDrivePath, 1) <> "\" Then sDrivePath = sDrivePath & "\"
    
    lngBuffSize = 50
    strVolume = String$(lngBuffSize, vbNullChar)
    
    ' Volumename der ISO ermitteln
    If GetVolumeNameForVolumeMountPoint(StrPtr(sDrivePath), _
        StrPtr(strVolume), lngBuffSize) = API_TRUE Then
                
        strRet = CutNull(strVolume)
                
    End If
    
    ' gefundenen Laufwerksbuchstaben zurck geben
    GetVolumePathFromDrivePath = strRet
    
End Function

Private Function GetDriveLetterFromDrivePath(ByVal sDrivePath As String) As String

    Dim lngBuffSize As Long
    
    Dim strRet As String
    Dim strVolume As String
    Dim strDriveLetter As String
    
    strVolume = GetVolumePathFromDrivePath(sDrivePath)
    
    If Len(strVolume) > 0& Then
        
        strDriveLetter = String(MAX_PATH, vbNullChar)
        
        ' zugewiesenen Laufwerksbuchstaben ermitteln
        If GetVolumePathNamesForVolumeName(StrPtr(strVolume), _
            StrPtr(strDriveLetter), MAX_PATH, lngBuffSize) = API_TRUE Then
                
            strRet = CutNull(strDriveLetter)
                
        End If
        
    End If
        
    ' gefundenen Laufwerksbuchstaben zurck geben
    GetDriveLetterFromDrivePath = strRet
    
End Function

Private Function Str2Guid(ByVal sGUID As String) As GUID

    ' GUID-String zu Type GUID konvertieren
    Call CLSIDFromString(StrPtr(sGUID), Str2Guid)
    
End Function

Private Function CutNull(ByVal sValue As String) As String

    Dim lngRet As Long
    Dim strRet As String
    
    lngRet = InStr(1, sValue, vbNullChar)
    
    If lngRet > 1 Then
    
        strRet = Mid$(sValue, 1, lngRet - 1)
        
    Else
    
        strRet = sValue
        
    End If
    
    CutNull = strRet
    
End Function

